//  tut11.c
//  10/30/94

#include "tuthd.h"

char source[256][3];
char dest[256][3];
int dir;

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure LoadCELPal (FileName : String; Var Palette : Pallette);
//   { This loads in the pallette of the .CEL file into the variable Palette }
void loadcelpal(char* FileName, char Palette[][3] )
{
  FILE* fptr;

  if((fptr=fopen(FileName,"rb"))==NULL)
  {
    printf("Error opening file %s\n",FileName); 
	exit(1);
  }
  fseek(fptr,(long)32,SEEK_SET);
  fread(Palette,1,768,fptr);
  fclose(fptr);
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Init;
void Init()
{
  _fmemset(source,0,768);
  _fmemset(dest,0,768);
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure SetItUp;
//   { We define our third screen here }
void SetItUp()
{
    int loop1,loop2,loop3;
	char Pal1[256][3];
	char Pal2[256][3];
	int change;
	char r,g,b,r1,g1,b1;
	int where;

//    Cls (0,Vaddr2);

    for(loop1=0;loop1<256;loop1++) Pal ((char)loop1,0,0,0);

    Flip2(Vaddr2,VGA); //andadd

    loadcelpal ("to.cel",Pal2);
    LoadCEL ("to.cel",Virtual2);

    Flip2(Vaddr2,VGA);

    loadcelpal ("from.cel",Pal1);
    LoadCEL ("from.cel",Virtual);

    where=0;

    for(loop1=0;loop1<320;loop1++)
    for(loop2=0;loop2<200;loop2++)
    {
      if((GetPixel(loop1,loop2,Vaddr)!=0) || (GetPixel (loop1,loop2,VGA)!=0))
      {
	change=FALSE;
	r=Pal1[GetPixel(loop1,loop2,Vaddr)][0];
	g=Pal1[GetPixel(loop1,loop2,Vaddr)][1];
	b=Pal1[GetPixel(loop1,loop2,Vaddr)][2];
	r1=Pal2[GetPixel(loop1,loop2,VGA)][0];
	g1=Pal2[GetPixel(loop1,loop2,VGA)][1];
	b1=Pal2[GetPixel(loop1,loop2,VGA)][2];

	for(loop3=0;loop3<=where;loop3++)
	  if ((source[loop3][0]==r) && (source[loop3][1]==g) && (source[loop3][2]==b) &&
	     (dest[loop3][0]==r1) && (dest[loop3][1]==g1) && (dest[loop3][2]==b1))
	  {
	     PutPixel (loop1,loop2,(char)loop3,Vaddr2);
	     change=TRUE;
	  }
	//  { Here we check that this combination hasn't occured before. If it
	//    has, put the appropriate pixel onto the third screen (vaddr2) }

	if (!(change) )
	{
	  where++;
          if (where==256)
          {
	    SetText();
            printf("Pictures have too many colors! Squeeze then retry!\n");
            exit(1);
            // { There were too many combinations of colors. Alter picture and
            //  then retry }
			// E.g. 16 colors per picture would be a max of 256 combinations, so
			// should work every time.
          }
          PutPixel(loop1,loop2,(char)where,Vaddr2);
          source[where][0]=Pal1[GetPixel(loop1,loop2,Vaddr)][0];
          source[where][1]=Pal1[GetPixel(loop1,loop2,Vaddr)][1];
          source[where][2]=Pal1[GetPixel(loop1,loop2,Vaddr)][2];
          dest[where][0]=Pal2[GetPixel(loop1,loop2,VGA)][0];
          dest[where][1]=Pal2[GetPixel(loop1,loop2,VGA)][1];
          dest[where][2]=Pal2[GetPixel(loop1,loop2,VGA)][2];
          //  { Create a new color and set it's from and to pallette values }
        }
      }
    }
//  Cls (0,VGA);
//  Flip2(Vaddr2,VGA);
    Flip(Vaddr,VGA);
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Crossfade (direction:boolean;del,farin:word);
// { This fades from one picture to the other in the direction specified
//   with a del delay. It crossfades one degree for every value in farin.
//   If farin=63, then a complete crossfade occurs }
void Crossfade(int direction, int del, int farin)
{
  int loop1,loop2;
  char temp[256][3];
  char far* tempptr=&temp[0][0];
    
  if (direction)
  {
    _fmemcpy(temp,source,768);
    for(loop1=0;loop1<256;loop1++)
      Pal ((char)loop1,source[loop1][0],source[loop1][1],source[loop1][2]);
    for(loop1=0;loop1<=farin;loop1++)
    {
      WaitRetrace();
      SetAllPal(tempptr);

      for(loop2=0;loop2<256;loop2++)
      {
        if( temp[loop2][0]<dest[loop2][0])temp[loop2][0]++;
        if( temp[loop2][0]>dest[loop2][0])temp[loop2][0]--;
        if( temp[loop2][1]<dest[loop2][1])temp[loop2][1]++;
        if( temp[loop2][1]>dest[loop2][1])temp[loop2][1]--;
        if( temp[loop2][2]<dest[loop2][2])temp[loop2][2]++;
        if( temp[loop2][2]>dest[loop2][2])temp[loop2][2]--;                 
        //  { Move temp (the current pallette) from source to dest }
      }
      delay1 (del);
    }
  }
  else 
  {
    _fmemcpy(temp,dest,768);
    for(loop1=0;loop1<256;loop1++)
      Pal ((char)loop1,dest[loop1][0],dest[loop1][1],dest[loop1][2]);
    for(loop1=0;loop1<=farin;loop1++)
    {
      WaitRetrace();
      SetAllPal(tempptr);

      for(loop2=0;loop2<256;loop2++)
      {
        if( temp[loop2][0]<source[loop2][0])temp[loop2][0]++;
        if( temp[loop2][0]>source[loop2][0])temp[loop2][0]--;
        if( temp[loop2][1]<source[loop2][1])temp[loop2][1]++;
        if( temp[loop2][1]>source[loop2][1])temp[loop2][1]--;
        if( temp[loop2][2]<source[loop2][2])temp[loop2][2]++;
        if( temp[loop2][2]>source[loop2][2])temp[loop2][2]--;                 
        //  { Move temp (the current pallette) from source to dest }
      }
      delay1 (del);
    }
  }
}

void main()
{                      
  int loop1;
//andout  _clearscreen(_GCLEARSCREEN);
  clrscr();
  SetUpVirtual();
  SetMCGA();
  Init();
  SetItUp();
  for(loop1=0;loop1<256;loop1++)
  Pal((char)loop1,source[loop1][0],source[loop1][1],source[loop1][2]);
  Flip2(Vaddr2,VGA);
//  delay1 (3000);

//void Crossfade(int direction, int del, int farin)

  dir=TRUE;
  while(1)
  {
//    Crossfade(dir,20,63);
    Crossfade(dir,2,63);
    dir=1-dir; // Toggle
//    delay1 (1000);
    if(_bios_keybrd(_KEYBRD_READY))break;
  }
//  getch();
//  Crossfade(dir,20,20);
  Crossfade(dir,2,63);
//  getch();
  SetText();
}

/*
   Hello there! This trainer program is on cross fading. What will happen
   is this : The program will load in two .CEL files, FROM.CEL and TO.CEL
   into the virtual screen at vaddr and to the VGA screen. The pallettes
   of these two pictures are loaded into pal1 and pal2. Note that you
   could easily rewrite this to load in other types of files if you do
   not own Autodesk Animator to draw your files (The pictures presented
   here were drawn by Fubar, sqeezed by me ;)). A third screen is then
   generated into vaddr2 (this takes 5-10 seconds on my 386-40). Note
   that you could dump vaddr2 to disk as a file instead of calculating it
   each time...it would be faster and be half the size of the two pictures.
   The picture will then crossfade between the two. Hit a key and it will
   crossfade halfway and then exit.
*/
