/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// TUT9G.CPP - VGA Trainer Program 9 (in Turbo C++ 3.0)                    //
// Program Notes : This program demonstrates polygon moving and rotation.  //
//                                                                         //
// Author        : Grant Smith (Denthor) - denthor@beastie.cs.und.ac.za    //
// Translator    : Christopher G. Mann   - r3cgm@dax.cc.uakron.edu         //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////


  #include <conio.h>         // clrscr(), getch(), kbhit()
  #include <iostream.h>      // cout()
  #include <math.h>          // sin(), cos()
  #include <stdlib.h>        // exit()
  #include <bios.h>
  #include "gfx2.cpp"        // our graphics library tools


// TYPEDEFS //

  typedef unsigned char byte;
  typedef unsigned int  word;


// CONSTANTS //

  const maxpolys   = 6;   //andadd
  const POLYPOINTS = 4;
  const POLYCORDS  = 3;


// LETTER DATA //


  int Z[maxpolys][POLYPOINTS][POLYCORDS] =                      //andadd
	    { {{-7,-10,-5},{10,7,-5},{7,10,-5},{-10,-7,-5}},
	      {{7,-10,-5},{-10,7,-5},{-7,10,-5},{10,-7,-5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{-7,-10,5},{10,7,5},{7,10,5},{-10,-7,5}},
	      {{7,-10,5},{-10,7,5},{-7,10,5},{10,-7,5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}} };


  int X[maxpolys][POLYPOINTS][POLYCORDS] =                //andadd
       { {{-12,-12,12},{-12,12,12},{12,12,12},{12,-12,12}},
	 {{-12,-12,-12},{-12,12,-12},{12,12,-12},{12,-12,-12}},
	 {{-12,-12,-12},{-12,12,-12},{-12,12,12},{-12,-12,12}},
	 {{12,-12,-12},{12,12,-12},{12,12,12},{12,-12,12}},
	 {{12,-12,12},{12,-12,-12},{-12,-12,-12},{-12,-12,12}},
	 {{12,12,12},{12,12,-12},{-12,12,-12},{-12,12,12}} };


  int C[maxpolys][POLYPOINTS][POLYCORDS] =                       //andadd
	    { {{-7,-15,-5},{15,7,-5},{7,15,-5},{-15,-7,-5}},
	      {{7,-15,-5},{-15,7,-5},{-7,15,-5},{15,-7,-5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{-7,-15,5},{15,7,5},{7,15,5},{-15,-7,5}},
	      {{7,-15,5},{-15,7,5},{-7,15,5},{15,-7,5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}} };

  int A[maxpolys][POLYPOINTS][POLYCORDS] =                       //andadd
	    { {{-7,-15,-5},{15,7,-5},{7,15,-5},{-15,-7,-5}},
	      {{7,-15,-5},{-15,7,-5},{-7,15,-5},{15,-7,-5}},
	      {{-12,-12,-12},{-12,12,-12},{-12,12,12},{-12,-12,12}},
	      {{-7,-15,5},{15,7,5},{7,15,5},{-15,-7,5}},
	      {{7,-15,5},{-15,7,5},{-7,15,5},{15,-7,5}},
	      {{12,12,12},{12,12,-12},{-12,12,-12},{-12,12,12}} };

  int S[maxpolys][POLYPOINTS][POLYCORDS] =                       //andadd
	    { {{-7,-15,-5},{15,7,-5},{7,15,-5},{-15,-7,-5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{-12,-12,-12},{-12,12,-12},{-12,12,12},{-12,-12,12}},
	      {{-7,-15,5},{15,7,5},{7,15,5},{-15,-7,5}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{12,12,12},{12,12,-12},{-12,12,-12},{-12,12,12}} };

  int D[maxpolys][POLYPOINTS][POLYCORDS] =                       //andadd
	    { {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{-12,-12,-12},{-12,12,-12},{-12,12,12},{-12,-12,12}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{0,0,0},{0,0,0},{0,0,0},{0,0,0}},
	      {{12,12,12},{12,12,-12},{-12,12,-12},{-12,12,12}} };

struct IPoint
{
  int x;
  int y;
  int z;
};  
struct IPoint lines[maxpolys][4],translated[maxpolys][4];
int lookup[360][2];  // sin and cos table
int poly1[200][2];
int ytopclip,ybotclip;
int xoff,yoff,zoff;


//                     //
// FUNCTION PROTOTYPES //
//                     //

  void Drawpoly1    (int x1,int y1,int x2,int y2,int x3,    //andadd
		     int y3,int x4,int y4,char color,int where);
  void Setuppoints1 ();                            //andadd
  void Rotatepoints1(int X, int Y, int Z);         //andadd
  void Drawpoints1  ();
  void MoveAround1  ();
  void MoveAround2  ();                           //andadd
  void MoveAround3  ();                           //andadd
  void MoveAround4  ();
  void MoveAround5  ();                           //andadd
  void MoveAround6  ();                           //andadd
  void MoveIt       ();                           //andadd
  void MoveZ        ();                           //andadd
  void MoveX        ();                           //andadd
  void MoveC        ();                           //andadd
  void MoveA        ();                           //andadd
  void MoveS        ();                           //andadd
  void MoveD        ();                           //andadd
  int  round   (float x);
  void PutPixel1(int X, int Y, char Color, int Where);
  void Line2(int x1, int y1, int x2, int y2,
	       unsigned char Color, int where);

//            //
// STRUCTURES //
//            //

  // The data for every point we rotate
  struct Point {
    float x;
    float y;
    float z;
  };

//                              //
// GLOBAL VARIABLE DECLARATIONS //
//                              //

  byte far *Virscr=NULL;           // Pointer to our virtual screen
  word Vaddr;                      // Segment of our virtual screen
  float Lookup[360][2];            // Our sin and cos lookup tables
  int Xoff, Yoff, Zoff;            // Used for movement of the object

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                                MAIN FUNCTION                              //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void main() {

  SetUpVirtual(Virscr,Vaddr);
  // always check to see if enough memory was allocated
  if (Virscr == NULL) {
    SetText();
    cout << "Insufficient memory for virtual screens, exiting...";
    exit(1);
  }

  int ch;

  clrscr();
  SetMCGA();
  Setuppoints1();
  MoveIt();
  ShutDown(Virscr);
  SetText();

}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Hline (x1,x2,y:word;col:byte;where:word); assembler;
//  { This draws a horizontal line from x1 to x2 on line y in color col }
// Version of Hline to add to the current screen color, for "glenzing"
void Hline2(int x1, int x2, int y, char col, int where)
{
 asm mov   ax,where
 asm mov   es,ax
 asm mov   ax,y
 asm mov   di,ax
 asm shl   ax,8
 asm shl   di,6
 asm add   di,ax
 asm add   di,x1
 asm mov   cx,x2
 asm sub   cx,x1
 asm cmp   cx,0
 asm jle   End
 Loop1:
 asm mov   al,es:[di] // ;  Read current color
 asm add   al,col     // ;  Add to new color
 asm stosb            // ;  Write new pixel
 asm loop  Loop1
 End:
}

///////////////////////////////////////////////////////////////////////////
//Procedure doside (x1,y1,x2,y2:integer);
//  { This scans the side of a polygon and updates the poly variable }
void doside(int x1,int y1,int x2,int y2)
{
  int temp,x,xinc,loop1;
  
  if(y1==y2)return;
  if(y2<y1)
  {
    temp=y2;
    y2=y1;
    y1=temp;
    temp=x2;
    x2=x1;
    x1=temp;
  }
  xinc=((x2-x1)<<7)/(y2-y1);
  x=(x1<<7);
  for(loop1=y1;loop1<=y2;loop1++)
  {
    if((loop1>ytopclip-1)&&(loop1<ybotclip+1))
    {
      if((x>>7)<poly1[loop1][0]) poly1[loop1][0]=(x>>7); // min
      if((x>>7)>poly1[loop1][1]) poly1[loop1][1]=(x>>7); // max
    }
    x+=xinc;
  }
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// Procedure Drawpoly1(x1,y1,x2,y2,x3,y3,x4,y4:integer;color:byte;where:word);
// This draw a polygon with 4 points at x1,y1 , x2,y2 , x3,y3 , x4,y4
// in color col }
void Drawpoly1(int x1,int y1,int x2,int y2,int x3,
     int y3,int x4,int y4,char color,int where)
{
  int miny,maxy,loop1;

asm    mov   si,offset poly1
asm    mov   cx,200
Loop1:
asm    mov   ax,32766
asm    mov   ds:[si],ax
asm    inc   si
asm    inc   si
asm    mov   ax,-32767
asm    mov   ds:[si],ax
asm    inc   si
asm    inc   si
asm    loop  Loop1
// { Setting the minx and maxx values to extremes }
  miny=y1;
  maxy=y1;
  if (y2<miny)  miny=y2;
  if (y3<miny)  miny=y3;
  if (y4<miny)  miny=y4;
  if (y2>maxy)  maxy=y2;
  if (y3>maxy)  maxy=y3;
  if (y4>maxy)  maxy=y4;
  if (miny<ytopclip)  miny=ytopclip;
  if (maxy>ybotclip)  maxy=ybotclip;
  if ((miny>199) || (maxy<0)) return;

  doside (x1,y1,x2,y2);
  doside (x2,y2,x3,y3);
  doside (x3,y3,x4,y4);
  doside (x4,y4,x1,y1);

  for( loop1= miny;loop1<=maxy;loop1++)
    Hline2 (poly1[loop1][0],poly1[loop1][1],loop1,color,where);
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure Setuppoints1;
//  { This creates the lookup table }
void Setuppoints1()
{
  int loop1;
  for(loop1=0;loop1<360;loop1++)
  {
    lookup[loop1][0]=round((float)sin((double)rad(loop1))*(float)16384);
    lookup[loop1][1]=round((float)cos((double)rad(loop1))*(float)16384);
  }
}

int round(float x)
{
  if(x>=0)
    return (int)(x+0.5);
  else
    return (int)(x-0.5);
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure Rotatepoints1 (x,Y,z:Integer);
//  { This rotates the object in lines to translated }
void Rotatepoints1(int x, int y, int z)
{
  int loop1,loop2;
  int a,b,c;
  
  for(loop1=0;loop1<maxpolys;loop1++)
  {
    for(loop2=0;loop2<4;loop2++)
    {
      b=lookup[y][1];
      c=lines[loop1][loop2].x;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        mov   a,dx
      }
      b=lookup[y][0];
      c=lines[loop1][loop2].z;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        add   a,dx
      }
      translated[loop1][loop2].x=a;
      translated[loop1][loop2].y=lines[loop1][loop2].y;
      b=-lookup[y][0];
      c=lines[loop1][loop2].x;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        mov   a,dx
      }
      b=lookup[y][1];
      c=lines[loop1][loop2].z;
      asm {
        mov   ax,b
        imul  c
        sal   ax,1
        rcl   dx,1
        sal   ax,1
        rcl   dx,1
        add   a,dx
      }
      translated[loop1][loop2].z=a;


      if(x!=0)
      {
        b=lookup[x][1];
        c=translated[loop1][loop2].y;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[x][0];
        c=translated[loop1][loop2].z;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          sub   a,dx
        }
        b=lookup[x][0];
        c=translated[loop1][loop2].y;
        translated[loop1][loop2].y=a;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[x][1];
        c=translated[loop1][loop2].z;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          add   a,dx
        }
        translated[loop1][loop2].z=a;
      }

      if(z!=0)
      {
        b=lookup[z][1];
        c=translated[loop1][loop2].x;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[z][0];
        c=translated[loop1][loop2].y;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          sub   a,dx
        }
        b=lookup[z][0];
        c=translated[loop1][loop2].x;
        translated[loop1][loop2].x=a;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
          sal   ax,1
          rcl   dx,1
          mov   a,dx
        }
        b=lookup[z][1];
        c=translated[loop1][loop2].y;
	asm {
          mov   ax,b
          imul  c
          sal   ax,1
          rcl   dx,1
	  sal   ax,1
          rcl   dx,1
          add   a,dx
        }
        translated[loop1][loop2].y=a;
      }
    }
  }
}

//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//  Procedure Drawpoints1;
//  { This draws the translated object to the virtual screen }
void Drawpoints1()
{
  int loop1;
  int temp;
  int nx;
  int tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4;
  
  for(loop1=0;loop1<maxpolys;loop1++)
  {
    if((translated[loop1][0].z+zoff<0)&&(translated[loop1][1].z+zoff<0)
     &&(translated[loop1][2].z+zoff<0)&&(translated[loop1][3].z+zoff<0))
     {
      temp=round (translated[loop1][0].z)+zoff;
      nx=translated[loop1][0].x;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx1=nx;
      nx=translated[loop1][0].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty1=nx;

      temp=round (translated[loop1][1].z)+zoff;
      nx=translated[loop1][1].x;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx2=nx;
      nx=translated[loop1][1].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty2=nx;

      temp=round (translated[loop1][2].z)+zoff;
      nx=translated[loop1][2].x;
      asm  {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx3=nx;
      nx=translated[loop1][2].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty3=nx;

      temp=round (translated[loop1][3].z)+zoff;
      nx=translated[loop1][3].x;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,160
        mov   nx,ax
      }
      tx4=nx;
      nx=translated[loop1][3].y;
      asm {
        mov   ax,nx
        mov   dx,ax
        sal   ax,8
        sar   dx,8
        idiv  temp
        add   ax,100
        mov   nx,ax
      }
      ty4=nx;

      Drawpoly1 (tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4,(char)(loop1),Vaddr);
    }
  }
}

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure Pal(ColorNo : Byte; R,G,B : Byte);
void Pal(char ColorNo, char R, char G, char B)
//  This sets the Red, Green and Blue values of a certain color 
{
   outportb(0x3c8,ColorNo);
   outportb(0x3c9,R);
   outportb(0x3c9,G);
   outportb(0x3c9,B);
}
//////////////////////////////////////////////////////////////////

    void Line2(int x1, int y1, int x2, int y2,
	       unsigned char Color, int Where)

//////////////////////////////////////////////////////////////////
{
  int dx,dy,incr1,incr2,d,x,y,xend,yend,yinc,xinc;

  dx=abs(x2-x1);
  dy=abs(y2-y1);

  if(dx>=dy) // slope < 1
  {
    if(x1>x2)
	{
	  x=x2; y=y2; xend=x1;
	  if(dy==0) yinc=0;
	  else { if(y2>y1) yinc=-1; else yinc=1;}
	}
	else
	{
	  x=x1; y=y1; xend=x2;
	  if(dy==0) yinc=0;
	  else { if(y2>y1) yinc=1; else yinc=-1;}
	}
    incr1=2*dy; d=incr1-dx; incr2=2*(dy-dx);
	PutPixel1(x,y,Color,Where);
    while(x<xend)
    {
      x++;
      if(d<0) d+=incr1;
      else { y+=yinc; d+=incr2;}
	  PutPixel1(x,y,Color,Where);
    }
  }
  else
  {
    if(y1>y2)
	{ 
	  x=x2; y=y2; yend=y1;
	  if(dx==0) xinc=0;
	  else { if(x2>x1) xinc = -1; else xinc = 1;}
    }
	else
	{
	  x=x1; y=y1; yend=y2;
	  if(dx==0) xinc=0;
	  else { if(x2>x1) xinc=1; else xinc = -1;}
	}
	incr1=2*dx; d=incr1-dy; incr2=2*(dx-dy);
	PutPixel1(x,y,Color,Where);
	while(y<yend)
	{
	  y++;
	  if(d<0) d+=incr1;
	  else { x+=xinc; d+=incr2; }
	  PutPixel1(x,y,Color,Where);
	}
  }
}

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//Procedure PutPixel1 (X,Y : Integer; Col : Byte);
//  This puts a pixel on the screen by writing directly to memory. 

void PutPixel1(int X, int Y, char Color, int Where)
{
  unsigned char far* VGAScreenPtr;
  unsigned int offset;
//    VGAScreenPtr=MK_FP(Where,(unsigned)(X+(Y*320)));
  offset=(unsigned)X + (unsigned)(Y<<8) + (unsigned)(Y<<6);

//screen = (unsigned int *) MK_FP(0xB000, 0); //from help

//  VGAScreenPtr=MK_FP(Where,offset);
    VGAScreenPtr=(unsigned char *)MK_FP(Where,offset); //andadd
   *VGAScreenPtr=Color;
}     
//{DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
//procedure WaitRetrace; assembler;
/*
    This waits until you are in a Verticle Retrace ... this means that all
    screen manipulation you do only appears on screen in the next verticle
    retrace ... this removes most of the "fuzz" that you see on the screen
    when changing the pallette. It unfortunately slows down your program
    by "synching" your program with your monitor card ... it does mean
    that the program will run at almost the same speed on different
    speeds of computers which have similar monitors. In our SilkyDemo,
    we used a WaitRetrace, and it therefore runs at the same (fairly
    fast) speed when Turbo is on or off. 
*/

void WaitRetrace()
{
  asm  mov dx,3DAh
l1:
 asm   in al,dx
 asm   and al,08h
 asm   jnz l1
l2:
 asm   in al,dx
 asm   and al,08h
 asm   jz  l2
}

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}
// procedure flip(source,dest:Word);
//   { This copies the entire screen at "source" to destination }
void Flip2(int Source, int Dest)
{
  asm {
    push    ds
    mov     ax, Dest
    mov     es, ax
    mov     ax, Source
    mov     ds, ax
    xor     si, si
    xor     di, di
    mov     cx, 32000
    rep     movsw
    pop     ds
  }
}

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

 void MoveIt() {

    int ch;

  cout << "\rType one: Q, W, E, R, T or Y";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
      case 'q': SetMCGA(); MoveAround1();
		cout << "\rType W, E, R, T or Y, Esc to quit  ";
		break;
      case 'w': SetMCGA(); MoveAround2();
		cout << "\rType Q, E, R, T or Y, Esc to quit  ";
		break;
      case 'e': SetMCGA(); MoveAround3();
		cout << "\rType Q, W, R, T or Y, Esc to quit  ";
		break;
      case 'r': SetMCGA(); MoveAround4();
		cout << "\rType Q, W, E, T or Y, Esc to quit  ";
		break;
      case 't': SetMCGA(); MoveAround5();
		cout << "\rType Q, W, E, R or Y, Esc to quit  ";
		break;
      case 'y': SetMCGA(); MoveAround6();
		cout << "\rType Q, W, E, R or Y, Esc to quit  ";
		break;

     }
    }
   }   while(ch != 0x1B); // if the escape code was 27 (escape key) then exit
  }

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MoveAroundX() - This is the main display function.  First it brings the  //
//                object towards the viewer by increasing the Zoff, then   //
//                it passes control to the user.                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void MoveAround1() {

  int ch;
  int loop1;

 cout << "\rType one: Z X C            ";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MoveAround2() - This is the main display function.  First it brings the  //
//                object towards the viewer by increasing the Zoff, then   //
//                it passes control to the user.                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void MoveAround2() {

  int ch;
  int loop1;

  for(loop1=1;loop1<16;loop1++)            //andadd
    Pal((char)loop1,(char)(loop1*4+3),0,(char)(27-(loop1*4+3)));

 cout << "\rType one: Z X C";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MoveAround3() - This is the main display function.  First it brings the  //
//                object towards the viewer by increasing the Zoff, then   //
//                it passes control to the user.                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void MoveAround3() {

  int ch;
  int loop1;

  for(loop1=1;loop1<16;loop1++)            //andadd
    Pal((char)loop1,(char)(loop1*4+3),0,(char)(30-(loop1*4+3)));

 cout << "\rType one: Z X C";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

void MoveAround4() {

  int ch;
  int loop1;

  for(loop1=1;loop1<16;loop1++)            //andadd
    Pal((char)loop1,(char)(loop1*4+3),0,(char)(33-(loop1*4+3)));

 cout << "\rType one: Z X C            ";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }
/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MoveAround5() - This is the main display function.  First it brings the  //
//                object towards the viewer by increasing the Zoff, then   //
//                it passes control to the user.                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void MoveAround5() {

  int ch;
  int loop1;

  for(loop1=1;loop1<16;loop1++)            //andadd
    Pal((char)loop1,(char)(loop1*4+3),0,(char)(49-(loop1*4+3)));

 cout << "\rType one: Z X C";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
// MoveAround6() - This is the main display function.  First it brings the  //
//                object towards the viewer by increasing the Zoff, then   //
//                it passes control to the user.                           //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

void MoveAround6() {

  int ch;
  int loop1;

  for(loop1=1;loop1<16;loop1++)            //andadd
    Pal((char)loop1,(char)(loop1*4+3),0,(char)(63-(loop1*4+3)));

 cout << "\rType one: Z X C";

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {
	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

void MoveZ()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=Z[loop1][loop2][0]*8;
      lines[loop1][loop2].y=Z[loop1][loop2][1]*8;
      lines[loop1][loop2].z=Z[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);
  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

  cout << "\rType one: Z X C, that was Z";      //andadd

  do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

// {DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD}

void MoveX()
{
  int deg,loop1,loop2;
  int clipincr=1; // clipincr must divide 100;
  int ch;

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=X[loop1][loop2][0]*8;
      lines[loop1][loop2].y=X[loop1][loop2][1]*8;
      lines[loop1][loop2].z=X[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
//  delay (500);
//  for(loop1=0;loop1<50/clipincr;loop1++)
  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    Rotatepoints1(deg,deg,deg);   //andadd

//    deg = (deg + 5) % 360;   //andadd
    deg = (deg + 3) % 360;   //andadd

    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }

  while(1)
  {

    Drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);
    Rotatepoints1(deg,deg,deg);         //andadd

//    deg = (deg + 5) % 360;       //andadd
    deg = (deg + 1) % 360;       //andadd


    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: Z X C, that was: X";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

void MoveC()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=C[loop1][loop2][0]*8;
      lines[loop1][loop2].y=C[loop1][loop2][1]*8;
      lines[loop1][loop2].z=C[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);

  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: X Y Z, that was Z";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

void MoveA()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=A[loop1][loop2][0]*8;
      lines[loop1][loop2].y=A[loop1][loop2][1]*8;
      lines[loop1][loop2].z=A[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);

  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: Z X C, that was A";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }
//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

void MoveS()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=S[loop1][loop2][0]*8;
      lines[loop1][loop2].y=S[loop1][loop2][1]*8;
      lines[loop1][loop2].z=S[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
  delay (500);

  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: Z X C, that was S";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }
//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD

void MoveD()
{
  int deg,loop1,loop2;
  int degincr=2;  // degincr must divide 360!
  int clipincr=1; // clipincr must divide 100;
  int ch;

  deg=0;
  Cls (0,Vaddr);
  for(loop1=0;loop1<maxpolys;loop1++)
    for(loop2=0;loop2<4;loop2++)
    {
      lines[loop1][loop2].x=D[loop1][loop2][0]*8;
      lines[loop1][loop2].y=D[loop1][loop2][1]*8;
      lines[loop1][loop2].z=D[loop1][loop2][2]*8;
    }

  Cls(0,Vaddr);
  Cls(0,VGA);
  xoff=160;
  yoff=100;
  zoff=-500;

  ytopclip=101;
  ybotclip=100;
  Line2(0,100,319,100,0,VGA);
//  delay (500);

  for(loop1=0;loop1<100/clipincr;loop1++)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,ytopclip,319,ytopclip,0,Vaddr);
    Line2(0,ybotclip,319,ybotclip,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!
    ytopclip=ytopclip-clipincr;
    ybotclip=ybotclip+clipincr;
  }
  while(1)
  {
    Rotatepoints1(deg,deg,deg);
    Drawpoints1();
    Line2(0,0,319,0,0,Vaddr);
    Line2(0,199,319,199,0,Vaddr);
    WaitRetrace();
    Flip2(Vaddr,VGA);
    Cls (0,Vaddr);

    deg+=degincr; if(deg==360)deg=0; // Be sure decincr divides 360!

    if(_bios_keybrd(_KEYBRD_READY))
    {
      ch=(0x00ff&getch());
      if(ch==0x1b)break;
    }
  }

 cout << "\rType one: Z X C, that was D";      //andadd

 do {
     if (kbhit()) {
      ch = getch();
      switch (ch) {

	case 'z': MoveZ(); break;
	case 'x': MoveX(); break;
	case 'c': MoveC(); break;
	case 'a': MoveA(); break;
	case 's': MoveS(); break;
	case 'd': MoveD(); break;
    }
   }
  }   while (ch != 0x1B); // if the escape code was 27 (escape key) then exit
 }

/*
   Welcome to the fourteenth trainer! This one is on glenzing, and also
   throws in a faster poly, fixed point math and a lot more assembler.
   This isn't very interactive ... hit any key to start, and then
   hit the [ESC] key to exit. It is a glenzed cube spinning in the
   middle of the screen. Read the text file for more information on
   how the fixed point etc. works ... it will also help a lot if you
   compare it with TUTPROG9.PAS, as this is the same 3D system, just
   speeded up.');
*/






